var HomeCare = (function (api) {

    // unique identifier for this plugin...
    var uuid = 'C8E2B9D0-3E82-11E4-916C-0800200C9A66';

    var HOME_CARE_SID = "urn:micasaverde-com:serviceId:HomeCare1";

    var myModule = {};

    var device = api.getCpanelDeviceId();
    var UI_Version = api.getUserData();
    var hcg_userList = [];
    var hcg_deviceData = [];
    var hcg_Errors = [];
    var hcg_nErrors = 0;
    var notifyRow = 0;
    var offset = 0;
    var flagDelete = false;
    var flagAdd = false;
    var flagError = false;

    function appendInterval(l, m) {
        if (flagAdd == false) {
            appendInactivityPeriod(l);
            var length = hcg_deviceData[l].intervals.length;
            var len = hcg_deviceData[l].intervals[m].length;
            hcg_deviceData[l].intervals[m].push("0");
            hcg_deviceData[l].intervals[m].push("1");
            hcg_deviceData[l].intervals[m].push("2");
            hcg_deviceData[l].intervals[m].push("3");
            for (var i = 0; i < 4; i++) {
                hcg_Errors[m].push(false);
            }
            var html = '<p id="dev_' + l + 'notify_row_' + len + '">';
            html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + len + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][len], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + len + ')" style="width:15%; margin-left:16%; text-align:center" />';
            html += '&nbsp;:&nbsp;';
            html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + (len + 1) + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][len + 1], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + (len + 1) + ')" style="width:15%; text-align:center" />';
            html += '&nbsp;-&nbsp;';
            html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + (len + 2) + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][len + 2], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + (len + 2) + ')" style="width:15%; text-align:center" />';
            html += '&nbsp;:&nbsp;';
            html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + (len + 3) + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][len + 3], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + (len + 3) + ')" style="width:15%; text-align:center" />';
            html += '</p>';
            notifyRow += 4;
            var table = jQuery('#dev_' + l + 'notify_table').append(html);
            flagAdd = true;
        }
    }

    function appendInactivityPeriod(l) {
        var len = hcg_deviceData[l].period.length;
        hcg_deviceData[l].period.push("0");
        var html = '<p id="dev_' + l + 'inactivity_period_' + (len - 1) + '">';
        html += '<input type="text" maxlength="4" id="dev_' + l + 'period_' + (len - 1) + '" value="' + hcg_deviceData[l].period[len] + '" onChange="HomeCare.UpdatePeriod(' + l + ',' + len + ',this.value)" style="width:50%; margin-left:9%; text-align:center" />';
        html += '</p>';
        var column = jQuery('#dev_' + l + 'inactivity_period_column').append(html);

    }


    function DeletePeriod(l, m) {
        var element = document.getElementById("dev_" + l + "inactivity_period_" + m);
        element.parentNode.removeChild(element);
        hcg_deviceData[l].period.splice(m);
    }

    function DeleteRow(l, m) {
        var len = hcg_deviceData[l].intervals[m].length;
        if (flagDelete == false) {
            DeletePeriod(l, hcg_deviceData[l].period.length - 1);
            if (len == 0) {
                console.log("We have 0 rows!!!!!");
                return;
            }
            else {
                var element = document.getElementById("dev_" + l + "notify_row_" + (len - 4));
                element.parentNode.removeChild(element);
                hcg_deviceData[l].intervals[m].splice(len - 4);
                hcg_Errors[m].splice(len - 4);
                notifyRow = len - 4;
            }
            flagDelete = true;
        }
    }


    function UpdateInterval(time, intervalIdy, intervalIdx) {

        time = time * 1;
        intervalIdx = intervalIdx * 1;
        intervalIdy = intervalIdy * 1;
        if (intervalIdx % 2 == 0) {
            if (isNaN(time) || time < 0 || time > 23) {
                hcg_Errors[intervalIdy][intervalIdx] = true;
                return;
            }
            else
                hcg_Errors[intervalIdy][intervalIdx] = false;
        }
        if (intervalIdx % 2 == 1) {
            if (isNaN(time) || time < 0 || time > 59) {
                hcg_Errors[intervalIdy][intervalIdx] = true;
                return;
            }
            else
                hcg_Errors[intervalIdy][intervalIdx] = false;
        }
        for (var i = 0; i < hcg_deviceData.length; i++) {
            for (j = 0; j < hcg_deviceData[i].intervals.length; j++) {
                for (var k = 0; k < hcg_deviceData[i].intervals[j].length; k++) {
                    var element = document.getElementById("dev_" + i + "notify_" + k);
                    var val = element.value;
                    hcg_deviceData[i].intervals[j][k] = val;
                }
            }
        }
    }


    function PackDeviceData(device) {
        for (var p = 0; p < hcg_Errors.length; p++) {
            for (var r = 0; r < hcg_Errors[p].length; r++) {
                if (hcg_Errors[p][r]) {
                    flagError = true;
                }
            }
        }

        if (hcg_nErrors === 0 && flagError == false) {
            var deviceData = [];
            for (var i = 0; i < hcg_deviceData.length; i++) {
                var info = "d" + hcg_deviceData[i].devNum;
                for (var k = 0; k < hcg_deviceData[i].period.length; k++) {
                    info += ",i" + hcg_deviceData[i].period[k];
                }
                for (var j = 0; j < hcg_deviceData[i].intervals.length; j++) {
                    var k = 0;
                    while (k < hcg_deviceData[i].intervals[j].length) {
                        info += ",sh" + hcg_deviceData[i].intervals[j][k] + ",sm" + hcg_deviceData[i].intervals[j][k + 1] + ",eh" + hcg_deviceData[i].intervals[j][k + 2] + ",em" + hcg_deviceData[i].intervals[j][k + 3];
                        k += 4;
                    }
                }
                info += ",n" + (hcg_deviceData[i].enabled === "checked" ? "1" : "0");
                deviceData.push(info);
            }
            deviceData = deviceData.join(';');

            // TODO: AJAX request to set variable
            var cmdUrl = data_command_url +
                "/data_request?id=variableset" +
                "&DeviceNum=" + device +
                "&serviceId=" + HOME_CARE_SID +
                "&Variable=" + "DeviceData" +
                "&Value=" + encode_string(deviceData);

            new Ajax.Request(cmdUrl,
                {
                    method: 'GET',
                    onSuccess: function (transport) {
                        ShowStatus("Data updated", false);
                    },
                    onFailure: function (transport) {
                        ShowStatus("Failed to update data. Reload LuuP and try again", true);
                    }
                });
        }
        else {
            ShowStatus("Could not save the changes. There is one or more invalid values", true);
        }
        flagDelete = false;
        flagAdd = false;
        flagError = false;
        api.setDeviceStateVariable(device, HOME_CARE_SID, "DeviceData", deviceData, 0);
    }


    function ShowStatus(text, error) {
        if (!error) {
            document.getElementById("status_display").style.backgroundColor = "#90FF90";
            document.getElementById("status_display").innerHTML = text;
        }
        else {
            document.getElementById("status_display").style.backgroundColor = "#FF9090";
            document.getElementById("status_display").innerHTML = text;
        }
    }


    function PadLeft(str, count) {
        str = str + ""; // Convert to string.
        count = count || 2;
        var diff = count - str.length;
        var padding = "";
        if (diff > 0) {
            while (diff--) {
                padding += "0";
            }
        }
        return padding + str;
    }

    function UnpackDeviceData(device) {
        hcg_deviceData = [];

        var deviceData = api.getDeviceState(device, HOME_CARE_SID, "DeviceData");
        if (deviceData === undefined || deviceData === "")
            return;
        deviceData = deviceData.split(';');
        for (var i = 0; i < deviceData.length; i++) {
            // Get the intervals.
            var intervals = [];
            var pattern = /sh(\d+),sm(\d+),eh(\d+),em(\d+)/g;
            var period = [];
            var pattern2 = /i(\d+),/g;
            var val2;
            while (val2 = pattern2.exec(deviceData[i])) {
                for (k = 1; k < val2.length; k++) {
                    period.push(val2[k]);
                }

            }
            var interval = [];
            var val;
            var j = 1;
            while (val = pattern.exec(deviceData[i])) {
                interval.push(val[j]);
                interval.push(val[j + 1]);
                interval.push(val[j + 2]);
                interval.push(val[j + 3]);
            }
            intervals.push(interval);
            var intervalError = [];
            for (var pp = 0; pp < interval.length; pp++) {
                intervalError.push(false);
            }
            hcg_Errors.push(intervalError);
            hcg_deviceData.push(
                {
                    devNum: /d(\d+)/.exec(deviceData[i])[1],
                    period: period,
                    intervals: intervals,
                    enabled: (/n(\d)/.exec(deviceData[i])[1] === "1") ? "checked" : ""
                });
        }
    }


    function UpdateEnabled(idx, object) {
        hcg_deviceData[idx].enabled = (object.checked === true) ? "checked" : "";
    }

    function insertInterval(l, m, n) {
        var html = '<p id="dev_' + l + 'notify_row_' + n + '">';
        html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + n + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][n], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + n + ')" style="width:15%; margin-left:16%; text-align:center" />';
        html += '&nbsp;:&nbsp;';
        html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + (n + 1) + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][n + 1], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + (n + 1) + ')" style="width:15%; text-align:center" />';
        html += '&nbsp;-&nbsp;';
        html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + (n + 2) + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][n + 2], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + (n + 2) + ')" style="width:15%; text-align:center" />';
        html += '&nbsp;:&nbsp;';
        html += '<input type="text" maxlength="2" id="dev_' + l + 'notify_' + (n + 3) + '" value="' + PadLeft(hcg_deviceData[l].intervals[m][n + 3], 2) + '" onChange="HomeCare.UpdateInterval(this.value,' + m + ',' + (n + 3) + ')" style="width:15%; text-align:center" />';
        html += '</p>';
        return html
    }

    function UpdatePeriod(idx, idx2, newValue) {
        var val = newValue * 1; // Convert to int.

        if (isNaN(val) || val < 0) {
            if (!UpdatePeriod.error) {
                UpdatePeriod.error = true;
                hcg_nErrors++;
            }
            return;
        }

        // The values are correct. Update the device data.
        hcg_deviceData[idx].period[idx2] = val + ""; // Convert back to string.
        if (UpdatePeriod.error) {
            UpdatePeriod.error = false;
            hcg_nErrors--;
        }
    }

    function insertInactivityPeriod(l, m) {
        var html = '<p id="dev_' + l + 'inactivity_period_' + m + '">';
        html += '<input type="text" maxlength="4" id="dev_' + l + 'period_' + hcg_deviceData[l].devNum + '" value="' + hcg_deviceData[l].period[m] + '" onChange="HomeCare.UpdatePeriod(' + l + ',' + m + ', this.value)" style="width:50%; margin-left:9%; text-align:center" />';
        html += '</p>';
        return html;
    }

    function UnpackUserList(device) {
        var userList = api.getDeviceState(device, HOME_CARE_SID, "UserList");
        if (userList !== undefined && userList !== "" && userList != "0") {
            hcg_userList = userList.split(',');
            var idx = hcg_userList.indexOf("0");
            if (idx !== -1) {
                hcg_userList.splice(idx, 1);
            }
        }
    }

    function UpdateUserList(object, device) {
        if (object.checked === true) {
            // Add the user to the list.
            hcg_userList.push(object.value);
        }
        else {
            // Remove the user from the list.
            var idx = hcg_userList.indexOf(object.value);
            if (idx !== -1) {
                hcg_userList.splice(idx, 1);
            }
        }

        // Update the UserList state variable.
        var userList = hcg_userList.join(',');
        if (userList == "") {
            userList = "0";
        }

        api.setDeviceStateVariable(device, HOME_CARE_SID, 'UserList', userList, UpdateUserListSuccess);
    }

    function UpdateUserListSuccess() {
        console.log('userlist successfully updated');
    }

    function UserIsChecked(userName) {
        if (hcg_userList.indexOf(userName) !== -1) {
            return 'checked';
        }

        return '';
    }

    function onBeforeCpanelClose(args) {
        console.log('handler for before cpanel close');
    }

    function init() {
        // register to events...
        api.registerEventHandler('on_ui_cpanel_before_close', myModule, 'onBeforeCpanelClose');
    }

    function ShowUsers() {
        try {
            init();

            var html = '';
            var numUsers = UI_Version.users.length;
            if (numUsers > 0) {
                UnpackUserList(device);
                html = '<p style="margin-top:10px; margin-left:10px">Select users to notify:</p>';
                for (var i = 0; i < numUsers; i++) {
                    var userName = UI_Version.users[i].Name;
                    html += '<p style="margin-left:10px"><input type="checkbox" value="' + userName + '" onClick="HomeCare.UpdateUserList(this,' + device + ')" ' + UserIsChecked(userName) + ' />&nbsp;' + userName + '</p>';
                }
            }
            else {
                html = '<p style="margin-top:10px; margin-left:10px">No users to notify</p>';
            }

            api.setCpanelContent(html);
        } catch (e) {
            Utils.logError('Error in HomeCare.ShowUsers(): ' + e);
        }
    }

    function ShowDevices() {
        try {
            var html = '';

            UnpackDeviceData(device);

            if (hcg_deviceData.length > 0) {
                // Area to display statuses and error messages.
                html += '<p id="status_display" style="width:90%; position:relative; margin-left:auto; margin-right:auto; table-layout:fixed; text-align:center; color:black"></div>';

                html += '<table style="width:90%; position:relative; margin-left:auto; margin-right:auto">';

                // Show titles
                html += '<tr>';
                html += '<td style="font-weight:bold; text-align:center; width:30%">Device name</td>';
                html += '<td style="font-weight:bold; text-align:center; width:10%">Inactivity period</td>';
                html += '<td style="font-weight:bold; text-align:center; width:40%">Notify between</td>';
                html += '<td style="font-weight:bold; text-align:center; width:10%">Send notifications</td>';
                html += '<td style="font-weight:bold; text-align:center; width:10%"></td>';
                html += '</tr>';

                // Show device list
                for (var i = 0; i < hcg_deviceData.length; i++) {
                    html += '<tr>';
                    html += '<td style="padding-left:5%">#' + hcg_deviceData[i].devNum + ' - ' + api.getDisplayedDeviceName(hcg_deviceData[i].devNum) + '</td>';
                    html += '<td id = "dev_' + i + 'inactivity_period_column">';
                    for (var jj = 0; jj < hcg_deviceData[i].period.length; jj++) {
                        html += insertInactivityPeriod(i, jj);
                    }
                    html += '</td>';
                    html += '<td id="dev_' + i + 'notify_table">';
                    var j = 0;
                    for (j = 0; j < hcg_deviceData[i].intervals.length; j++) {
                        var k = 0;
                        while (k < hcg_deviceData[i].intervals[j].length) {
                            html += insertInterval(i, j, k);
                            k += 4;
                        }
                    }
                    notifyRow = k;
                    html += '</td>';
                    html += '<td><input type="checkbox" value="' + hcg_deviceData[i].devNum + '" onClick="HomeCare.UpdateEnabled(' + i + ', this)" ' + hcg_deviceData[i].enabled + ' style="margin-left:42%" /></td>';
                    html += '<td><input type="button" value="    Add   " onClick="HomeCare.appendInterval(' + i + ',' + (j - 1) + ')" style="margin-left:50%" /><input type="button" value="Delete" onClick="HomeCare.DeleteRow(' + i + ',' + (j - 1) + ')" style="margin-left:50%" /></td>';
                    html += '</tr>';
                }

                // Create empty row
                html += '<tr>';
                html += '<td colspan="4"><br /></td>';
                html += '</tr>';

                // Display the 'Update' button
                html += '<tr>';
                html += '<td colspan="3"><input type="button" value="Update" onClick="HomeCare.PackDeviceData(' + device + ')" style="margin-left:60%" /></td>';
                html += '</tr>';

                html += '</table>';
            } else {
                html += '<p style="margin-left:10px; margin-top:10px">No security sensors</p>';
            }

            api.setCpanelContent(html);
        } catch (e) {
            Utils.logError('Error in HomeCare.ShowDevices(): ' + e);
        }
    }

    myModule = {
        uuid: uuid,

        init: init,

        onBeforeCpanelClose: onBeforeCpanelClose,

        UpdateUserList: UpdateUserList,
        UpdatePeriod: UpdatePeriod,
        UpdateEnabled: UpdateEnabled,
        UpdateInterval: UpdateInterval,
        PackDeviceData: PackDeviceData,
        appendInterval: appendInterval,
        DeleteRow: DeleteRow,

        ShowUsers: ShowUsers,
        ShowDevices: ShowDevices
    };

    return myModule;
})(api);



//*****************************************************************************
// Extension of the Array object:
//  indexOf : return the index of a given element or -1 if it doesn't exist
//*****************************************************************************
if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function (element /*, from*/) {
        var len = this.length;

        var from = Number(arguments[1]) || 0;
        if (from < 0) {
            from += len;
        }

        for (; from < len; from++) {
            if (from in this && this[from] === element) {
                return from;
            }
        }
        return -1;
    };
}